//	Copyright (c) 1982 Dyadic Systems Limited	


#if HAS_UNICODE	
#include <uniav.h>

#define AV_NEWLINE 0x0085	// UNICODE NEL character
#define AV_VARIANT 0x2360	// "Quad colon"

#else //HAS_UNICODE

#define AV_NEWLINE 0x03	

#if defined AV_NAMES

#define	ADD_AV(name,val)     #name
char* QuadAVnames[]=

#else //defined AV_NAMES

#define	ADD_AV(name,val)     name=val
typedef enum

#endif //defined AV_NAMES
	{
	ADD_AV	(	AV_AV0		,	0x00),
	ADD_AV	(	AV_BS		,	0x01),
	ADD_AV	(	AV_LF		,	0x02),
	ADD_AV	(	AV_CR		,	0x03),
	ADD_AV	(	AV_SP		,	0x04),		
	ADD_AV	(	AV_AV5		,	0x05),		
	ADD_AV	(	AV_AV6		,	0x06),		
	ADD_AV	(	AV_AV7		,	0x07),		
	ADD_AV	(	AV_AV8		,	0x08),
	ADD_AV	(	AV_TAB		,	0x09),
	ADD_AV	(	AV_IBEAM	,	0x0a),
	ADD_AV	(	AV_BSTILE	,	0x0b),
	ADD_AV	(	AV_PERCENT	,	0x0c),
	ADD_AV	(	AV_QUOTE	,	0x0d),
	ADD_AV	(	AV_ALPHA	,	0x0e),
	ADD_AV	(	AV_OMEGA	,	0x0f),
	ADD_AV	(	AV_UNDER	,	0x10),
	ADD_AV	(	AV_AL		,	0x11),
	ADD_AV	(	AV_BL		,	0x12),
	ADD_AV	(	AV_CL		,	0x13),
	ADD_AV	(	AV_DL		,	0x14),
	ADD_AV	(	AV_EL		,	0x15),
	ADD_AV	(	AV_FL		,	0x16),
	ADD_AV	(	AV_GL		,	0x17),
	ADD_AV	(	AV_HL		,	0x18),
	ADD_AV	(	AV_IL		,	0x19),
	ADD_AV	(	AV_JL		,	0x1a),
	ADD_AV	(	AV_KL		,	0x1b),
	ADD_AV	(	AV_LL		,	0x1c),
	ADD_AV	(	AV_ML		,	0x1d),
	ADD_AV	(	AV_NL		,	0x1e),
	ADD_AV	(	AV_OL		,	0x1f),
	ADD_AV	(	AV_PL		,	0x20),
	ADD_AV	(	AV_QL		,	0x21),
	ADD_AV	(	AV_RL		,	0x22),
	ADD_AV	(	AV_SL		,	0x23),
	ADD_AV	(	AV_TL		,	0x24),
	ADD_AV	(	AV_UL		,	0x25),
	ADD_AV	(	AV_VL		,	0x26),
	ADD_AV	(	AV_WL		,	0x27),
	ADD_AV	(	AV_XL		,	0x28),
	ADD_AV	(	AV_YL		,	0x29),
	ADD_AV	(	AV_ZL		,	0x2a),
	ADD_AV	(	AV_AV2B		,	0x2b),
	ADD_AV	(	AV_AV2C		,	0x2c),
	ADD_AV	(	AV_HIGH		,	0x2d),
	ADD_AV	(	AV_POINT	,	0x2e),
	ADD_AV	(	AV_ZILDE	,	0x2f),
	ADD_AV	(	AV_ZERO		,	0x30),
	ADD_AV	(	AV_ONE		,	0x31),
	ADD_AV	(	AV_TWO		,	0x32),
	ADD_AV	(	AV_THREE	,	0x33),
	ADD_AV	(	AV_FOUR		,	0x34),
	ADD_AV	(	AV_FIVE		,	0x35),
	ADD_AV	(	AV_SIX		,	0x36),
	ADD_AV	(	AV_SEVEN	,	0x37),
	ADD_AV	(	AV_EIGHT	,	0x38),
	ADD_AV	(	AV_NINE		,	0x39),
	ADD_AV	(	AV_AV3A		,	0x3a),
	ADD_AV	(	AV_RTACK	,	0x3b),
	ADD_AV	(	AV_AV3C		,	0x3c),
	ADD_AV	(	AV_DOLLAR	,	0x3d),
	ADD_AV	(	AV_POUND	,	0x3e),
	ADD_AV	(	AV_CENT		,	0x3f),
	ADD_AV	(	AV_DELTA	,	0x40),
	ADD_AV	(	AV_A 		,	0x41),
	ADD_AV	(	AV_B 		,	0x42),
	ADD_AV	(	AV_C 		,	0x43),
	ADD_AV	(	AV_D 		,	0x44),
	ADD_AV	(	AV_E 		,	0x45),
	ADD_AV	(	AV_F 		,	0x46),
	ADD_AV	(	AV_G 		,	0x47),
	ADD_AV	(	AV_H 		,	0x48),
	ADD_AV	(	AV_I 		,	0x49),
	ADD_AV	(	AV_J 		,	0x4a),
	ADD_AV	(	AV_K 		,	0x4b),
	ADD_AV	(	AV_L 		,	0x4c),
	ADD_AV	(	AV_M 		,	0x4d),
	ADD_AV	(	AV_N 		,	0x4e),
	ADD_AV	(	AV_O 		,	0x4f),
	ADD_AV	(	AV_P 		,	0x50),
	ADD_AV	(	AV_Q 		,	0x51),
	ADD_AV	(	AV_R 		,	0x52),
	ADD_AV	(	AV_S 		,	0x53),
	ADD_AV	(	AV_T 		,	0x54),
	ADD_AV	(	AV_U 		,	0x55),
	ADD_AV	(	AV_V 		,	0x56),
	ADD_AV	(	AV_W 		,	0x57),
	ADD_AV	(	AV_X 		,	0x58),
	ADD_AV	(	AV_Y 		,	0x59),
	ADD_AV	(	AV_Z 		,	0x5a),
	ADD_AV	(	AV_AV5B 	,	0x5b),
	ADD_AV	(	AV_AV5C 	,	0x5c),
	ADD_AV	(	AV_AV5D 	,	0x5d),
	ADD_AV	(	AV_WDOT		,	0x5e), // white dot
	ADD_AV	(	AV_AV5F		,	0x5f), // white dot
	ADD_AV	(	AV_DELTAU	,	0x60),
	ADD_AV	(	AV_AU		,	0x61),
	ADD_AV	(	AV_BU		,	0x62),
	ADD_AV	(	AV_CU		,	0x63),
	ADD_AV	(	AV_DU		,	0x64),
	ADD_AV	(	AV_EU		,	0x65),
	ADD_AV	(	AV_FU		,	0x66),
	ADD_AV	(	AV_GU		,	0x67),
	ADD_AV	(	AV_HU		,	0x68),
	ADD_AV	(	AV_IU		,	0x69),
	ADD_AV	(	AV_JU		,	0x6a),
	ADD_AV	(	AV_KU		,	0x6b),
	ADD_AV	(	AV_LU		,	0x6c),
	ADD_AV	(	AV_MU		,	0x6d),
	ADD_AV	(	AV_NU		,	0x6e),
	ADD_AV	(	AV_OU		,	0x6f),
	ADD_AV	(	AV_PU		,	0x70),
	ADD_AV	(	AV_QU		,	0x71),
	ADD_AV	(	AV_RU		,	0x72),
	ADD_AV	(	AV_SU		,	0x73),
	ADD_AV	(	AV_TU		,	0x74),
	ADD_AV	(	AV_UU		,	0x75),
	ADD_AV	(	AV_VU		,	0x76),
	ADD_AV	(	AV_WU		,	0x77),
	ADD_AV	(	AV_XU		,	0x78),
	ADD_AV	(	AV_YU		,	0x79),
	ADD_AV	(	AV_ZU		,	0x7a),
	ADD_AV	(	AV_LBRACE	,	0x7b),
	ADD_AV	(	AV_EURO		,	0x7c),
	ADD_AV	(	AV_RBRACE	,	0x7d),
	ADD_AV	(	AV_LTACK	,	0x7e),
	ADD_AV	(	AV_SQUISH	,	0x7f),
	ADD_AV	(	AV_DIRESIS	,	0x80),
	ADD_AV	(	AV_ON		,	0x81),
	ADD_AV	(	AV_OVER		,	0x82),
	ADD_AV	(	AV_ARING	,	0x83),
	ADD_AV	(	AV_CONV		,	0x84),
	ADD_AV	(	AV_COMM		,	0x85),
	ADD_AV	(	AV_AV86		,	0x86),
	ADD_AV	(	AV_AV87		,	0x87),
	ADD_AV	(	AV_AV88		,	0x88),
	ADD_AV	(	AV_AV89		,	0x89),
	ADD_AV	(	AV_AV8a		,	0x8a),
	ADD_AV	(	AV_AV8b		,	0x8b),
	ADD_AV	(	AV_AV8c		,	0x8c),
	ADD_AV	(	AV_AV8d		,	0x8d),
	ADD_AV	(	AV_AV8e		,	0x8e),
	ADD_AV	(	AV_AV8f		,	0x8f),
	ADD_AV	(	AV_AV90		,	0x90),
	ADD_AV	(	AV_AV91		,	0x91),
	ADD_AV	(	AV_AV92		,	0x92),
	ADD_AV	(	AV_AV93		,	0x93),
	ADD_AV	(	AV_AV94		,	0x94),
	ADD_AV	(	AV_AV95		,	0x95),
	ADD_AV	(	AV_AV96		,	0x96),
	ADD_AV	(	AV_AV97		,	0x97),
	ADD_AV	(	AV_AV98		,	0x98),
	ADD_AV	(	AV_AV99		,	0x99),
	ADD_AV	(	AV_AV9a		,	0x9a),
	ADD_AV	(	AV_LBRACKET 	,	0x9b),
	ADD_AV	(	AV_SLASH	,	0x9c),
	ADD_AV	(	AV_BSLASH	,	0x9d),
	ADD_AV	(	AV_SLOPE	,	0x9e),
	ADD_AV	(	AV_BSLOPE	,	0x9f),
	ADD_AV	(	AV_LT		,	0xa0),
	ADD_AV	(	AV_LE		,	0xa1),
	ADD_AV	(	AV_EQ		,	0xa2),
	ADD_AV	(	AV_GE		,	0xa3),
	ADD_AV	(	AV_GT		,	0xa4),
	ADD_AV	(	AV_NE		,	0xa5),
	ADD_AV	(	AV_OR		,	0xa6),
	ADD_AV	(	AV_AND		,	0xa7),
	ADD_AV	(	AV_MINUS	,	0xa8),
	ADD_AV	(	AV_PLUS		,	0xa9),
	ADD_AV	(	AV_DIVIDE	,	0xaa),
	ADD_AV	(	AV_TIMES	,	0xab),
	ADD_AV	(	AV_QUERY	,	0xac),
	ADD_AV	(	AV_EPSILON 	,	0xad),
	ADD_AV	(	AV_RHO		,	0xae),
	ADD_AV	(	AV_TILDE	,	0xaf),
	ADD_AV	(	AV_UP		,	0xb0),
	ADD_AV	(	AV_DOWN		,	0xb1),
	ADD_AV	(	AV_IOTA		,	0xb2),
	ADD_AV	(	AV_CIRCLE	,	0xb3),
	ADD_AV	(	AV_STAR		,	0xb4),
	ADD_AV	(	AV_UPSTILE 	,	0xb5),
	ADD_AV	(	AV_DSTILE	,	0xb6),
	ADD_AV	(	AV_DEL		,	0xb7),
	ADD_AV	(	AV_JOT		,	0xb8),
	ADD_AV	(	AV_LPAREN	,	0xb9),
	ADD_AV	(	AV_LSHOE	,	0xba),
	ADD_AV	(	AV_RSHOE	,	0xbb),
	ADD_AV	(	AV_CAP		,	0xbc),
	ADD_AV	(	AV_CUP		,	0xbd),
	ADD_AV	(	AV_BASE		,	0xbe),
	ADD_AV	(	AV_TOP		,	0xbf),
	ADD_AV	(	AV_STILE	,	0xc0),
	ADD_AV	(	AV_SEMI		,	0xc1),
	ADD_AV	(	AV_COMMA	,	0xc2),
	ADD_AV	(	AV_NOR		,	0xc3),
	ADD_AV	(	AV_NAND		,	0xc4),
	ADD_AV	(	AV_DGRADE	,	0xc5),
	ADD_AV	(	AV_UPGRADE	,	0xc6),
	ADD_AV	(	AV_TRANSPOSE 	,	0xc7),
	ADD_AV	(	AV_CIRCLESTILE 	,	0xc8),
	ADD_AV	(	AV_BCIRCLE	,	0xc9),
	ADD_AV	(	AV_LOG		,	0xca),
	ADD_AV	(	AV_DOMINO	,	0xcb),
	ADD_AV	(	AV_SHRIEK	,	0xcc),
	ADD_AV	(	AV_THORN	,	0xcd),
	ADD_AV	(	AV_HYDRANT	,	0xce),
	ADD_AV	(	AV_DELTILDE 	,	0xcf),
	ADD_AV	(	AV_BCOMMA	,	0xd0),
	ADD_AV	(	AV_MATCH	,	0xd1),
	ADD_AV	(	AV_NOTMATCH 	,	0xd2),
	ADD_AV	(	AV_AVD3 	,	0xd3),
	ADD_AV	(	AV_AVD4 	,	0xd4),
	ADD_AV	(	AV_AVD5 	,	0xd5),
	ADD_AV	(	AV_AVD6 	,	0xd6),
	ADD_AV	(	AV_DQUOTE	,	0xd7),
	ADD_AV	(	AV_HASH		,	0xd8),
	ADD_AV	(	AV_AVD9		,	0xd9),
	ADD_AV	(	AV_AMPERSAND 	,	0xda),
	ADD_AV	(	AV_ACUTE	,	0xdb),
	ADD_AV	(	AV_LINE_LR 	,	0xdc),	// Lower  Right Corner	
	ADD_AV	(	AV_LINE_UR 	,	0xdd),	// Upper  Right Corner	
	ADD_AV	(	AV_LINE_UL 	,	0xde),	// Upper  Left  Corner	
	ADD_AV	(	AV_LINE_LL 	,	0xdf),	// Lower  Left  Corner	
	ADD_AV	(	AV_LINE_MM 	,	0xe0),	// Middle Middle Cross	
	ADD_AV	(	AV_LINE_HZ 	,	0xe1),	// Horizontal Line	
	ADD_AV	(	AV_LINE_ML 	,	0xe2),	// Middle Left   Tee	
	ADD_AV	(	AV_LINE_MR 	,	0xe3),	// Middle Right  Tee	
	ADD_AV	(	AV_LINE_LM 	,	0xe4),	// Lower  Middle Tee	
	ADD_AV	(	AV_LINE_UM 	,	0xe5),	// Upper  Middle Tee	
	ADD_AV	(	AV_LINE_VT 	,	0xe6),	// Vertical Line	
	ADD_AV	(	AV_ASCAT	,	0xe7),
	ADD_AV	(	AV_AVE8		,	0xe8),
	ADD_AV	(	AV_AVE9		,	0xe9),
	ADD_AV	(	AV_AVEA		,	0xea),
	ADD_AV	(	AV_CIRCUMFLEX 	,	0xeb),
	ADD_AV	(	AV_AVEC		,	0xec),
	ADD_AV	(	AV_GRAVE	,	0xed),
	ADD_AV	(	AV_ASCBAR	,	0xee),
	ADD_AV	(	AV_AVEF		,	0xef),
	ADD_AV	(	AV_COLON	,	0xf0),
	ADD_AV	(	AV_EPSUBAR	,	0xf1),
	ADD_AV	(	AV_AVF2		,	0xf2),
	ADD_AV	(	AV_AVF3		,	0xf3),
	ADD_AV	(	AV_DIAMOND	,	0xf4),
	ADD_AV	(	AV_LEFT		,	0xf5),
	ADD_AV	(	AV_RIGHT	,	0xf6),
	ADD_AV	(	AV_LAMP		,	0xf7),
	ADD_AV	(	AV_RPAREN	,	0xf8),
	ADD_AV	(	AV_RBRACKET 	,	0xf9),
	ADD_AV	(	AV_AVFA 	,	0xfa),
	ADD_AV	(	AV_AVFB 	,	0xfb),
	ADD_AV	(	AV_AVFC 	,	0xfc),
	ADD_AV	(	AV_QUAD		,	0xfd),
	ADD_AV	(	AV_QUADQUOTE 	,	0xfe),
	ADD_AV	(	AV_DIRESISSTAR	,	0xff)
#if defined AV_NAMES
	};
#else //defined AV_NAMES
	} QuadAV;
#endif //defined AV_NAMES

#undef ADD_AV



#endif // HAS_UNICODE

#define AV_SPACE 	AV_SP
#define AV_DOT 		AV_POINT

//#include <unicode.h>
//#include <utf.h>

extern const achar in_word_specials[];
extern bool IsLikeNewLine(uns c);
extern achar LineEnding(void);


//	Copyright 	(	c) 1982 Dyadic Systems Limited	

