#if	UNIX_H_INCLUDED // (already included)
#error	unix included twice
#else	//UNIX_H_INCLUDED

#define UNIX_H_INCLUDED	1

#if !defined(UNIX)

#if	POCKET_H_INCLUDED 	// is pocket.h included?


#endif	// POCKET_H_INCLUDED

extern char *ttyname(int fd);
extern char *uname(void);
extern int REMOTEFILE(int st_dev);
extern int alarm(void);
extern int pause(void );
extern int wait(int *stat_loc);
extern int32_t getuid(void);
extern unsigned int valid_fd(int fd);
#if !AP_BUILD
extern intptr_t LIBCALL execv(const char *path, const char *const *argv);
extern intptr_t LIBCALL execl(const char *path, const char *arg,...);
#endif
extern void force_user_io(int fd);
extern void fork(void);
#if WRITLOSS
extern int non_writloss_fsync_fn(int fd);
#define non_writloss_fsync non_writloss_fsync_fn
#else // WRITLOSS
extern int fsync(int fd);
#endif
extern void kill(int pid,int sig);
extern void slave(int *fd,UCH *path,UCH *cmd,UCH **params);
extern void sync(void );
extern void times(void);

extern void binary_stream(FILE *stream);
extern void text_stream(FILE *stream);
extern void binary_file(int fd);
extern void text_file(int fd);

#endif 	// !defined(UNIX)

extern int isadisk(int fd);
extern int is_user_io(int fd);

#endif	//UNIX_H_INCLUDED (file already included)
