
/* In some enviroments we can optimise the supplied setjmp(3) longjmp(3)
 * routines. This implies having to mess about with the signal(2) interface
 * to avoid signal blocking - see util.c
 */

#if	defined(SUN) && (! defined(SOLARIS))
#	define	SIG_BODGE
#	define	JMP_BODGE
#endif	// SUN 

#ifdef	SIG_BODGE
#define	signal(a,b)	Signal(a,b)	// special signal interface 
			(*Signal())();	// declare it 
#endif	// SIG_BODGE 

#ifdef	JMP_BODGE
#define longjmp _longjmp
#define setjmp	_setjmp
#endif	// JMP_BODGE 
